# demo_1: __repr__ and __str__
class Dog:
	""" A dog """
	# (3)
	def __init__(self):
		self.__repr__ = lambda: 'teddy'
		self.__str__ = lambda: 'a teddy'

	# (1)
	def __repr__(self):
		return 'Dog()'

	# (2)
	def __str__(self):
		return 'a dog'

# (4) replace the built-in repr() and str()
def repr(x): 
	return type(x).__repr__(x)

# Note this code (from cs61a) is not the real implementation for str()
def str(x):
	t = type(x)
	if hasattr(t, '__str__'):
		return t.__str__(x)
	else:	
		return repr(x)
    
# (1)
teddy = Dog()
print(teddy)
print(repr(teddy))
print(str(teddy))
print(teddy.__repr__())
print(teddy.__str__())







